def scale_reinit
	model = Sketchup.active_model
	sel = model.selection
	model.start_operation "reinit scale"
	sel.each do |e|
		if e.typename == "Group"
			scale_reinit_work(e)
		elsif e.typename == "ComponentInstance" and not e.definition.behavior.always_face_camera? and not e.definition.behavior.shadows_face_sun?
			scale_reinit_work(e)
		end	
	end
	model.commit_operation
end

def scale_reinit_work(ent)
	# le = [ent.bounds.width,ent.bounds.height,ent.bounds.depth]
	# ld = [ent.definition.bounds.width,ent.definition.bounds.height,ent.definition.bounds.depth]
	if ent.bounds.diagonal != ent.definition.bounds.diagonal
		Sketchup.active_model.active_entities.add_instance(ent.definition,ent.bounds.corner(0)) 
		ent.erase!
	end
end

def scale_reinit_ok
	model = Sketchup.active_model
	n = 0
	model.selection.each do |e|
		if e.typename == "ComponentInstance" 
			n += 1 if (e.bounds.diagonal != e.definition.bounds.diagonal) and not e.definition.behavior.always_face_camera? and not e.definition.behavior.shadows_face_sun?
		elsif e.typename == "Group"
			n += 1 if e.bounds.diagonal != e.definition.bounds.diagonal
		end
		return true if n > 1
	end
	return false
end

class Sketchup::Group 
	def definition
		Sketchup.active_model.definitions.each do |d|
			d.instances.each{|i| return d if i == self}
		end
	end
end

if not file_loaded?("scale_reinit.rb")
	UI.add_context_menu_handler do |menu|
		menu.add_item("Reset scale"){ scale_reinit } if scale_reinit_ok
	end

end
file_loaded("scale_reinit.rb")